#ifndef _NONSTD_STDIO_H_
#define _NONSTD_STDIO_H_

bool fileExists(const char* path);
bool removeFile(const char* path);

#ifdef _WIN32


#ifndef _MSC_VER
 #include <dir.h>
#else
 #ifndef MOBILE2D
 #include <direct.h>
 #endif
 #define mkdir _mkdir
#endif

#ifndef MOBILE2D
 #include <io.h> //borland compiler: include <io.h> before <dir.h> causes the SimWorld class in "simul.h" be unrecognized, for unknown reason :O moreover, this problem is only pertinent to the CLI project, not GUI. Maybe this is caused by global defines like NOVCL, NO_STRICT etc.?
 #define makeDirectory(name) mkdir(name) 
#endif


#else


 #include <unistd.h>
 #include <sys/stat.h>
 #define makeDirectory(name) mkdir(name,0777)

#endif


#include <stdio.h>

#if defined SHP && defined BADA_API_1

//sprintf* and others that work correctly are taken from <stdio.h>...

#include <FIo.h>


typedef Osp::Io::File MFILE;
MFILE *mfopen(const char*path,const char*mode);
void mfclose(MFILE *f);
int mfread(void *ptr, int size, int n, MFILE *f);
int mfwrite(const void *ptr, int size, int n, MFILE *f);
int mfputs(const char *, MFILE *);
int	mfseek(MFILE *, long, int);
long mftell(MFILE *);
char *mfgets(char *str, int num, MFILE *f);
int mfeof(MFILE *f);

//#define	SEEK_SET	0	/* set file offset to offset */
//#define	SEEK_CUR	1	/* set file offset to current plus offset */
//#define	SEEK_END	2	/* set file offset to EOF plus offset */
//int	sprintf(char *, const char *, ...);
//int	vsnprintf(char *,int, const char *, ...);

#else
 typedef FILE MFILE;
 #define mfopen fopen
 #define mfclose fclose
 #define mfread fread
 #define mfwrite fwrite
 #define mfputs fputs
 #define mfgets fgets
 #define mfeof feof
 #define mfseek fseek
 #define mftell ftell
#endif

#endif

